// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package useragentutilsconfig

import "encoding/json"
import "fmt"

// Schema for configuration of user-agent-utils enrichment
type A100 struct {
	// Enabled corresponds to the JSON schema field "enabled".
	Enabled bool `json:"enabled"`

	// Name corresponds to the JSON schema field "name".
	Name string `json:"name"`

	// Parameters corresponds to the JSON schema field "parameters".
	Parameters A100Parameters `json:"parameters,omitempty"`

	// Vendor corresponds to the JSON schema field "vendor".
	Vendor string `json:"vendor"`
}

type A100Parameters map[string]interface{}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A100) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["enabled"]; raw != nil && !ok {
		return fmt.Errorf("field enabled in A100: required")
	}
	if _, ok := raw["name"]; raw != nil && !ok {
		return fmt.Errorf("field name in A100: required")
	}
	if _, ok := raw["vendor"]; raw != nil && !ok {
		return fmt.Errorf("field vendor in A100: required")
	}
	type Plain A100
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A100(plain)
	return nil
}